package test;

import test.entity.OccupyPerX;
import test.entity.Point;
import test.entity.WholeIndexOccupy;

import java.lang.reflect.Array;
import java.util.ArrayList;

public class cal {

    ArrayList<OccupyPerX> occupyPerXArrayList = new ArrayList<>();

    public void countNumber(){

        GetPoints getPointsRealShape = new GetPoints();
        ArrayList<Point> realShapePoints = getPointsRealShape.returnPoints();//实际形状的平面坐标
        GetPoints getPoints = new GetPoints();//所有待计算点
        ArrayList<Point> allPoints = getPoints.returnPoints();//所有待计算点，铲车作业平面坐标
        Split split = new Split();
        split.cal(realShapePoints);

        ArrayList<Double> xIndexCorList = split.xIndexCorList;//格点横坐标List
        ArrayList<Double> yIndexCorList = split.yIndexCorList;//格点纵坐标List
        WholeIndexOccupy wholeIndexOccupy = split.wholeIndexOccupy;//初始垛位的占用情况
        Double xGap = split.xGap;//横向上采用的间隔
        Double yGap = split.yGap;//纵向上采用的间隔

        Double minX = xIndexCorList.get(0);
        Double maxX = xIndexCorList.get(xIndexCorList.size());
        Double minY = yIndexCorList.get(0);
        Double maxY = yIndexCorList.get(yIndexCorList.size());


        ArrayList<Point> pointAfterExclude = new ArrayList<>();//过滤后的所有点的坐标


        //对待计算点，进行过滤，过滤掉在网格以外的，这部分后面单独写个过滤类
        for(int i = 0 ; i < allPoints.size();i++){

            Point point = allPoints.get(i);
            Double corX = point.getColX();
            Double corY = point.getColY();

            if ( (corX < maxX) && (corX > minX) && (corY < maxY) && (corY > minY)){

                pointAfterExclude.add(point);

            }

        }

        //占用的网格为1，不占用的网格0
        ArrayList<ArrayList<Integer>> occupyList = changeWholeIndexOccupyToList(wholeIndexOccupy);

//        for (int i = 0 ; i < occupyList.size();i++){
//
//
//
//        }


        for (int i = 0; i < pointAfterExclude.size();i++){

            Point point = pointAfterExclude.get(i);
            Double x = point.getColX();
            Double y = point.getColY();
            Integer xIndex = split.identifyXIndex(x);
            Integer yIndex = split.identifyYIndex(y);
            ArrayList<Integer> arrayList = occupyList.get(xIndex);
            arrayList.set(yIndex,0);
            occupyList.set(xIndex,arrayList);

        }

        for (int i = 0 ; i < occupyList.size();i++){

            ArrayList<Integer> arrayList = occupyList.get(i);
            String arrayListString = arrayList.toString();
            String[] arrays = arrayListString.split("0");
            String maxString ="";


            //这里需要再想想
            for (int j = 0 ; j < arrays.length;j++){

                    String temp = arrays[j];
                    if (temp.length() > maxString.length()){

                        maxString = temp;
                    }

            }

            Integer indexBegin = arrayListString.indexOf(maxString) - 1;
            Integer indexEnd = indexBegin + maxString.length();

            OccupyPerX occupyPerX = new OccupyPerX();
            occupyPerX.setMinYIndex(indexBegin);
            occupyPerX.setMaxYIndex(indexEnd);
            occupyPerXArrayList.add(occupyPerX);

        }






    }



    public ArrayList<ArrayList<Integer>> changeWholeIndexOccupyToList(WholeIndexOccupy wholeIndexOccupy){

        ArrayList<OccupyPerX> occupyPerXArrayList = wholeIndexOccupy.getOccupyPerXArrayList();

        Integer numOfGaps = occupyPerXArrayList.size();

        ArrayList<ArrayList<Integer>> occupyList = new ArrayList<>();

        for (int i = 0 ; i < numOfGaps;i++){

            ArrayList<Integer> arrayList = new ArrayList<>();

            for (int j = 0 ; j < numOfGaps ; j++){

                arrayList.add(0);

            }
            occupyList.add(arrayList);
        }

        for (int i = 0 ; i < occupyPerXArrayList.size(); i++){

            OccupyPerX occupyPerX =  occupyPerXArrayList.get(i);

            Integer minYIndex = occupyPerX.getMinYIndex();

            Integer maxYIndex = occupyPerX.getMaxYIndex();

            ArrayList<Integer> arrayList = occupyList.get(i);

            for (int j = minYIndex ; j < (maxYIndex + 1); j++){

                arrayList.set(j,1);

            }

            occupyList.set(i,arrayList);

        }

        return occupyList;

    }

}
